package cc.toph.simplycompat.config;

import cc.toph.simplycompat.SimplyCompatExpectPlatform;

import java.util.HashMap;

public class ConfigProvider implements SimpleConfig.DefaultConfig {
    private final String namespace;
    private final HashMap<String, String> configMap = new HashMap<>();
    private String contents = String.format("""
            ## Simply Compat Config
            ## Version: %s
            
            """, SimplyCompatExpectPlatform.getVersion());

    public ConfigProvider(String namespace) {
        this.namespace = namespace;
    }


    public void addKeyValuePair(String key, Object value, String comment) {
        String stringValue = String.valueOf(value); // safely handle `null` too
        configMap.put(key, stringValue);
        contents += String.format("""
                # %s
                %s = %s
                
                """, comment, key, value);
    }

    @Override
    public String get(String namespace) {
        return contents;
    }

    @Override
    public HashMap<String, String> getMap() {
        return configMap;
    }

    public String getNamespace() {
        return namespace;
    }
}

