package cc.toph.simplycompat.registry;

import cc.toph.simplycompat.config.Config;
import cc.toph.simplycompat.config.ConfigProvider;

public final class ConfigRegistry {
    public static final class WEAPON_ATTRIBUTES {

        // Additional Additions //
        public static float ROSE_GOLD;
        public static boolean ROSE_GOLD_ENABLED;
        public static float GILDED_NETHERITE;
        public static boolean GILDED_NETHERITE_ENABLED;

        // Create //
        public static float STURDY;
        public static boolean STURDY_ENABLED;

        // Create: Deep Dark//
        public static float ECHO;
        public static boolean ECHO_ENABLED;

        // Pure Cooper Tools //
        public static float COPPER;
        public static boolean COPPER_ENABLED;
        public static float EXPOSED_COPPER;
        public static boolean EXPOSED_COPPER_ENABLED;
        public static float WEATHERED_COPPER;
        public static boolean WEATHERED_COPPER_ENABLED;
        public static float OXIDIZED_COPPER;
        public static boolean OXIDIZED_COPPER_ENABLED;

        // TFMG //
        public static float ALUMINUM;
        public static boolean ALUMINUM_ENABLED;
        public static float LEAD;
        public static boolean LEAD_ENABLED;
        public static float STEEL;
        public static boolean STEEL_ENABLED;


        public static final ConfigProvider PROVIDER = new ConfigProvider("weapon_attributes");

        public static void register() {
            Config config = new Config(PROVIDER);

            if (CompatRegistry.ADDITIONAL_ADDITIONS.passCheck()) {
                ROSE_GOLD = config.registerProp(
                        "rose_gold_damageModifier",
                        3.0f,
                        "Rose Gold Damage Modifier"
                );

                ROSE_GOLD_ENABLED = config.registerProp(
                        "rose_gold_enabled",
                        true,
                        "Enable Rose Gold Swords"
                );

                GILDED_NETHERITE = config.registerProp(
                        "gilded_netherite_damageModifier",
                        4.0f,
                        "Gilded Netherite Damage Modifier"
                );

                GILDED_NETHERITE_ENABLED = config.registerProp(
                        "gilded_netherite_enabled",
                        true,
                        "Enable Gilded Netherite Swords"
                );
            }

            if (CompatRegistry.CREATE.passCheck()) {
                STURDY = config.registerProp(
                        "sturdy_damageModifier",
                        3.5f,
                        "Sturdy Damage Modifier"
                );

                STURDY_ENABLED = config.registerProp(
                        "sturdy_enabled",
                        true,
                        "Enable Sturdy Swords"
                );
            }

            if (CompatRegistry.CREATE_DEEP_DARK.passCheck()) {

                ECHO = config.registerProp(
                        "echo_damageModifier",
                        5.0f,
                        "Steel Echo Modifier"
                );

                ECHO_ENABLED = config.registerProp(
                        "echo_enabled",
                        true,
                        "Enable Echo Swords"
                );
            }

            COPPER = config.registerProp(
                    "copper_damageModifier",
                    3.0f,
                    "Copper Damage Modifier"
            );

            COPPER_ENABLED = config.registerProp(
                    "copper_enabled",
                    true,
                    "Enable Copper Swords"
            );

            if (CompatRegistry.PURE_COPPER.passCheck()) {
                EXPOSED_COPPER = config.registerProp(
                        "exposed_copper_damageModifier",
                        3.0f,
                        "Copper Damage Modifier"
                );

                EXPOSED_COPPER_ENABLED = config.registerProp(
                        "exposed_copper_enabled",
                        true,
                        "Enable Exposed Copper Swords"
                );

                WEATHERED_COPPER = config.registerProp(
                        "weathered_copper_damageModifier",
                        3.0f,
                        "Copper Weathered Copper Modifier"
                );

                WEATHERED_COPPER_ENABLED = config.registerProp(
                        "exposed_copper_enabled",
                        true,
                        "Enable Exposed Copper Swords"
                );

                OXIDIZED_COPPER = config.registerProp(
                        "oxidized_copper_damageModifier",
                        3.5f,
                        "Copper Weathered Copper Modifier"
                );

                OXIDIZED_COPPER_ENABLED = config.registerProp(
                        "oxidized_copper_enabled",
                        true,
                        "Enable Oxidized Copper Swords"
                );
            }

            if (CompatRegistry.TFMG.passCheck()) {
                ALUMINUM = config.registerProp(
                        "aluminum_damageModifier",
                        2.5f,
                        "Aluminum Damage Modifier"
                );

                ALUMINUM_ENABLED = config.registerProp(
                        "aluminum_enabled",
                        true,
                        "Enable Aluminum Swords"
                );

                LEAD = config.registerProp(
                        "lead_damageModifier",
                        -0.5f,
                        "Lead Damage Modifier"
                );

                LEAD_ENABLED = config.registerProp(
                        "lead_enabled",
                        true,
                        "Enable Lead Swords"
                );
                STEEL = config.registerProp(
                        "steel_damageModifier",
                        3.5f,
                        "Steel Damage Modifier"
                );

                STEEL_ENABLED = config.registerProp(
                        "steel_enabled",
                        true,
                        "Enable Steel Swords"
                );
            }

            config.register();
        }
    }

    public static void registerConfigs() {
        WEAPON_ATTRIBUTES.register();
    }
}
